---
title: Pull latest changes for all git submodules
description:
date: 2024-03-08
id: 20240308072628
taxonomies:
  categories:
    - development
  tags:
    - git
license: CC0-1.0
---
If it's **the first time** you check-out a repo you need to use `--init` first:

```sh
git submodule update --init --recursive
```

After this you can just run:

```sh
git submodule update --recursive --remote
```

This has the added benefit of respecting any "non default" branches specified in the `.gitmodules` or `.git/config` files